#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>
#include <cstrike>
#include <xs>

#define PLUGIN	"Knife Power"
#define AUTHOR	"trofian"
#define VERSION	"1.1"

#define RESET_KNIFE_DELAY 3.0
#define RESET_KNIFE_DELAY_INVALID 1.0

#if cellbits == 32
	#define OFFSET_CSMONEY 115
#else
	#define OFFSET_CSMONEY 140
#endif

#pragma tabsize 0

new Float:g_gametime[33]
new knife_teleport_sound[] = "knife_power/14.wav"
new g_have_knife_power[33]

new g_used_count[33]

new g_cvar_left
new g_cvar_right
new g_cvar_cost
new g_cvar_mode
new g_cvar_r_delay

new stuck[33]

new const Float:size[][3] = {
	{0.0, 0.0, 1.0}, {0.0, 0.0, -1.0}, {0.0, 1.0, 0.0}, {0.0, -1.0, 0.0}, {1.0, 0.0, 0.0}, {-1.0, 0.0, 0.0}, {-1.0, 1.0, 1.0}, {1.0, 1.0, 1.0}, {1.0, -1.0, 1.0}, {1.0, 1.0, -1.0}, {-1.0, -1.0, 1.0}, {1.0, -1.0, -1.0}, {-1.0, 1.0, -1.0}, {-1.0, -1.0, -1.0},
	{0.0, 0.0, 2.0}, {0.0, 0.0, -2.0}, {0.0, 2.0, 0.0}, {0.0, -2.0, 0.0}, {2.0, 0.0, 0.0}, {-2.0, 0.0, 0.0}, {-2.0, 2.0, 2.0}, {2.0, 2.0, 2.0}, {2.0, -2.0, 2.0}, {2.0, 2.0, -2.0}, {-2.0, -2.0, 2.0}, {2.0, -2.0, -2.0}, {-2.0, 2.0, -2.0}, {-2.0, -2.0, -2.0},
	{0.0, 0.0, 3.0}, {0.0, 0.0, -3.0}, {0.0, 3.0, 0.0}, {0.0, -3.0, 0.0}, {3.0, 0.0, 0.0}, {-3.0, 0.0, 0.0}, {-3.0, 3.0, 3.0}, {3.0, 3.0, 3.0}, {3.0, -3.0, 3.0}, {3.0, 3.0, -3.0}, {-3.0, -3.0, 3.0}, {3.0, -3.0, -3.0}, {-3.0, 3.0, -3.0}, {-3.0, -3.0, -3.0},
	{0.0, 0.0, 4.0}, {0.0, 0.0, -4.0}, {0.0, 4.0, 0.0}, {0.0, -4.0, 0.0}, {4.0, 0.0, 0.0}, {-4.0, 0.0, 0.0}, {-4.0, 4.0, 4.0}, {4.0, 4.0, 4.0}, {4.0, -4.0, 4.0}, {4.0, 4.0, -4.0}, {-4.0, -4.0, 4.0}, {4.0, -4.0, -4.0}, {-4.0, 4.0, -4.0}, {-4.0, -4.0, -4.0},
	{0.0, 0.0, 5.0}, {0.0, 0.0, -5.0}, {0.0, 5.0, 0.0}, {0.0, -5.0, 0.0}, {5.0, 0.0, 0.0}, {-5.0, 0.0, 0.0}, {-5.0, 5.0, 5.0}, {5.0, 5.0, 5.0}, {5.0, -5.0, 5.0}, {5.0, 5.0, -5.0}, {-5.0, -5.0, 5.0}, {5.0, -5.0, -5.0}, {-5.0, 5.0, -5.0}, {-5.0, -5.0, -5.0}
}

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	register_cvar("knife_power_left", "1") // 0 -    , 1 - 
	register_cvar("knife_power_right", "1") // 0 -     (  ), 1 - 
	register_cvar("knife_power_cost", "200") // 
	register_cvar("knife_power_mode", "1") // 0 -    , 1 -   1 , 2 -    , , 3 -    ( t)
	
	register_cvar("knife_power_unstuck", "1") //  ( ,     )
	register_cvar("knife_power_mul4", "1") //    (knife)power  4 
	
	/*
	*   (-5  -2  .) -  ,   
	*        
	* 
	*   (1  7  .) -     
	*    1 
	* 
	* 0 -    ()
	*/
	register_cvar("knife_power_round_delay", "5")
	
	if(get_cvar_num("knife_power_mul4") == 1)
		RegisterHam(Ham_TakeDamage, "player", "HAM_TakeDamage")
	
	register_clcmd("get_knife_power", "get_knife")
	register_clcmd("say /knife_power", "get_knife")
	register_clcmd("say_team /knife_power", "get_knife")

	register_event("HLTV", "NewRound", "a", "1=0", "2=0")
	
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_knife", "HAM_Primary", 1)
	RegisterHam(Ham_Weapon_SecondaryAttack, "weapon_knife", "HAM_Secondary", 1)
}

public plugin_cfg()
{
	if(get_cvar_num("knife_power_unstuck") == 1)
		set_task(0.2,"checkstuck",0,"",0,"b") //   
		
	g_cvar_left = get_cvar_num("knife_power_left")
	g_cvar_right = get_cvar_num("knife_power_right")
	g_cvar_cost = get_cvar_num("knife_power_cost")
	g_cvar_mode = get_cvar_num("knife_power_mode")
	g_cvar_r_delay = get_cvar_num("knife_power_round_delay")
	
	if(g_cvar_r_delay > 0)
		for(new i = 1; i<=32; i++)
			g_used_count[i] = g_cvar_r_delay
	
	if(g_cvar_mode == 2)
		for(new i = 1; i<=32; i++)
			g_have_knife_power[i] = 1
}

public plugin_precache()
	precache_sound(knife_teleport_sound)

public HAM_Primary(gun)
{
	new id = get_pdata_cbase(gun, 41, 4)
	
	if(!(get_user_flags(id) & ADMIN_LEVEL_H) && g_cvar_mode == 3) //  t
		return HAM_IGNORED
	if(g_have_knife_power[id] == 0 && g_cvar_mode != 3)
		return HAM_IGNORED
	if(g_cvar_left == 0)
		return HAM_IGNORED
	
	new victim
	new body
	get_user_aiming(id, victim, body)
 
	if(body <= 0)
		return HAM_IGNORED
	
	if(cs_get_user_team(id) == cs_get_user_team(victim))
		return HAM_IGNORED
	
	new Float:fVelocity[3] = {0.0, 0.0, 0.0}
	fVelocity[0] = random_float(-700.0, 800.0)
	fVelocity[1] = random_float(-700.0, 800.0)
	fVelocity[2] = random_float(-700.0, 800.0)
	set_pev(victim, pev_velocity, fVelocity)
	
	return HAM_IGNORED
}

public HAM_Secondary(gun)
{
	new id = get_pdata_cbase(gun, 41, 4)
	
	if(!(get_user_flags(id) & ADMIN_LEVEL_H) && g_cvar_mode == 3) //  t
		return HAM_IGNORED
	if(g_have_knife_power[id] == 0 && g_cvar_mode != 3)
		return HAM_IGNORED
	if(g_cvar_right == 0)
		return HAM_IGNORED
	
	new victim
	new body
	get_user_aiming(id, victim, body)
 
	if(body <= 0)
		return HAM_IGNORED
	
	if(cs_get_user_team(id) == cs_get_user_team(victim))
		return HAM_IGNORED
	
	new Float:fAngles[3]
	pev(victim, pev_angles, fAngles)
	
	new Float:fOrigin[3]
	pev(victim, pev_origin, fOrigin)
	
	new Float:fPlayerOrigin[3]						// 
	new iPlayerOrigin[3]							// 
	pev(id, pev_origin, fPlayerOrigin)				// 
	FVecIVec(Float:fPlayerOrigin, iPlayerOrigin)	// 
	
	angle_vector(fAngles, ANGLEVECTOR_FORWARD, fAngles)
	
	new Float:fSetAngles[3]
	vector_to_angle(fAngles, fSetAngles)
	
	xs_vec_neg(fAngles, fAngles)
	
	new Float:fDistance[3]
	xs_vec_mul_scalar(fAngles, 42.0, fDistance)
	
	xs_vec_add(fOrigin, fDistance, fDistance)
	
	fDistance[2] += 17.0

	if (is_hull_vacant(fDistance, pev(id, pev_flags) & FL_DUCKING ? HULL_HEAD : HULL_HUMAN, id))
	{
		if(g_cvar_r_delay > 0)
		{
			if(g_used_count[id] == 0)
			{
				print_col_chat(id, "!g[%s] !yYou have spent all charges for this round.", PLUGIN)
				return PLUGIN_HANDLED
			}
			g_used_count[id]--
			print_col_chat(id, "!g[%s] !yYou have %d charges", PLUGIN, g_used_count[id])
		}
		
		if(g_cvar_r_delay < 0)
		{
			if(g_used_count[id] < 0 )
			{
				print_col_chat(id, "!g[%s] !yWait %d rounds", PLUGIN, abs(g_used_count[id]))
				return PLUGIN_HANDLED
			}
			
			g_used_count[id] = g_cvar_r_delay
		}
		
		set_pev(id, pev_angles, fSetAngles)
		set_pev(id, pev_fixangle, 1)
		set_pev(id, pev_origin, fDistance)
		
		g_gametime[id] = get_gametime() + RESET_KNIFE_DELAY
		
		engfunc(EngFunc_EmitSound, id, CHAN_STATIC, knife_teleport_sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
		
		new iDistance[3]
		FVecIVec(Float:fDistance, iDistance)
		
		Create_TE_TELEPORT(iPlayerOrigin)
		Create_TE_IMPLOSION(iDistance, 100, 45, 3)
		set_shake(id, 14, 10, 12)
	}
	else
	{
		g_gametime[id] = get_gametime() + RESET_KNIFE_DELAY_INVALID
		client_cmd(id, "spk ^"events/friend_died.wav^"")
		print_col_chat(id, "!g[%s] !yInvalid destination (", PLUGIN)
	}
	return HAM_IGNORED
}

public get_knife(id)
{
	new player_money = get_pdata_int(id, OFFSET_CSMONEY)
	
	if (player_money < g_cvar_cost)
	{
		print_col_chat(id, "!g[%s] !yNot enough money!", PLUGIN)
		return PLUGIN_HANDLED
	}
	
	if(g_have_knife_power[id] == 1 || g_cvar_mode == 3)
	{
		print_col_chat(id, "!g[%s] !yAlready have", PLUGIN)
		return PLUGIN_HANDLED
	}
	
	set_pdata_int(id, OFFSET_CSMONEY, player_money-g_cvar_cost)
	
	message_begin(MSG_ONE, get_user_msgid("Money"), {0, 0, 0}, id)
	write_long(player_money-g_cvar_cost)
	write_byte(1)
	message_end()
	
	g_have_knife_power[id] = 1
	print_col_chat(id, "!g[%s] !yYou have bought knife power! Have a good time ;)", PLUGIN)
	
	return PLUGIN_HANDLED
}

public NewRound()
{	
	for(new i = 1; i<=32; i++)
	{
		if(g_cvar_r_delay < 0)
		{
			if(g_used_count[i] < 0)
				g_used_count[i]++
		}
		
		if(g_cvar_r_delay > 0)
			g_used_count[i] = g_cvar_r_delay
		
		if(g_cvar_mode == 1)
			g_have_knife_power[i] = 0
	}
}

public HAM_TakeDamage(victim, inflictor, attacker, Float:damage, damage_type)
{
	if(!pev_valid(attacker))
		return HAM_IGNORED
	
	new Gun = get_user_weapon(attacker)
	if(Gun == CSW_KNIFE && g_have_knife_power[attacker] == 1)
		SetHamParamFloat(4, damage*4)
	
	return HAM_IGNORED
}  

public client_disconnect(id)
{
	g_have_knife_power[id] = 0
	g_used_count[id] = g_cvar_r_delay
}

stock set_shake(const player, iAmount = 14, iLong = 10, iFreq = 13)
{	
	message_begin(MSG_ONE, get_user_msgid("ScreenShake"), {0,0,0}, player)
	write_short(1<<iAmount) 	// shake amount
	write_short(1<<iLong) 		// shake lasts this long
	write_short(1<<iFreq) 		// shake noise frequency
	message_end()
}

stock print_col_chat(const id, const input[], any:...) 
{ 
	new count = 1, players[32]
	static msg[191]
	vformat(msg, 190, input, 3)
	replace_all(msg, 190, "!g", "^4") // Green Color 
	replace_all(msg, 190, "!y", "^1") // Default Color
	replace_all(msg, 190, "!t", "^3") // Team Color 
	
	if (id)
		players[0] = id
	else
		get_players(players, count, "ch")
	
	{
		for ( new i = 0; i < count; i++ )
		{
			if (is_user_connected(players[i]))
			{
				message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i])
				write_byte(players[i])
				write_string(msg)
				message_end()
			}
		}
	}
}

stock Create_TE_TELEPORT(position[3])
{
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY) 
	write_byte( TE_TELEPORT ) 
	write_coord( position[0] ) 
	write_coord( position[1] ) 
	write_coord( position[2] ) 
	message_end()
}

stock Create_TE_IMPLOSION(position[3], radius, count, life)
{
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
	write_byte ( TE_IMPLOSION )
	write_coord( position[0] )			// position (X)
	write_coord( position[1] )			// position (Y)
	write_coord( position[2] )			// position (Z)
	write_byte ( radius )				// radius
	write_byte ( count )				// count
	write_byte ( life )					// life in 0.1's
	message_end()
}

//
public checkstuck()
{
	static players[32], pnum, player
	get_players(players, pnum)
	static Float:origin[3]
	static Float:mins[3], hull
	static Float:vec[3]
	static o,i
	for(i=0; i<pnum; i++)
	{
		player = players[i]
		if (is_user_connected(player) && is_user_alive(player))
		{
			pev(player, pev_origin, origin)
			hull = pev(player, pev_flags) & FL_DUCKING ? HULL_HEAD : HULL_HUMAN
			if (!is_hull_vacant(origin, hull,player) && pev(player, pev_movetype) != MOVETYPE_NOCLIP && !(pev(player,pev_solid) & SOLID_NOT))
			{
				++stuck[player]
				if(stuck[player] >= 8) //!!!!!!!!!!!!!
				{
					pev(player, pev_mins, mins)
					vec[2] = origin[2]
					for (o=0; o < sizeof size; ++o)
					{
						vec[0] = origin[0] - mins[0] * size[o][0]
						vec[1] = origin[1] - mins[1] * size[o][1]
						vec[2] = origin[2] - mins[2] * size[o][2]
						if (is_hull_vacant(vec, hull,player))
						{
							engfunc(EngFunc_SetOrigin, player, vec)
							unstuckEffects(player)
							set_pev(player, pev_velocity,{0.0, 0.0, 0.0})
							o = sizeof size
						}
					}
				}
			}
			else
				stuck[player] = 0
		}
	}
}

stock bool:is_hull_vacant(const Float:origin[3], hull,id)
{
	static tr
	engfunc(EngFunc_TraceHull, origin, origin, 0, hull, id, tr)
	if (!get_tr2(tr, TR_StartSolid) || !get_tr2(tr, TR_AllSolid))
		return true
	return false
}

public unstuckEffects(id)
{
	set_hudmessage(255,150,50, -1.0, 0.65, 0, 6.0, 1.5,0.1,0.7)
	show_hudmessage(id,"You have been unstucked!")
	message_begin(MSG_ONE_UNRELIABLE,105,{0,0,0},id )      
	write_short(1<<10)   // fade lasts this long duration
	write_short(1<<10)   // fade lasts this long hold time
	write_short(1<<1)   // fade type (in / out)
	write_byte(20)            // fade red
	write_byte(255)    // fade green
	write_byte(255)        // fade blue
	write_byte(255)    // fade alpha
	message_end()
}